!  2.2 2̉@2@\ʎɉ̌vZ\
program quadratic_sample
   implicit none
   real a,b,c,x1,x2
   integer ib,nr
   a = 3
   c = 1
   do ib = 0, 10
      b = ib
      call quadratic(a,b,c,x1,x2,nr)
      print *,'b = ',b
      if (nr == 0) then
         print *,'No Roots !'
       else if (nr == 1) then
         print *,'Single Root : X = ',x1
       else if (nr == 2) then
         print *,'Two Real Roots : X1, X2 = ',x1,x2
       else
         print *,'Two Imaginary Roots : X1, X2 = ',x1,'+- i(',x2,')'
      endif
   enddo
end program quadratic_sample

subroutine quadratic(a,b,c,x1,x2,nroot)
   implicit none
   real a,b,c,x1,x2,D,d1,s
   integer nroot
   if (a == 0) then
      if (b == 0) then
         nroot = 0
       else
         x1 = -c/b
         nroot = 1
      endif
      return
   endif
   D = b*b - 4*a*c
   nroot = 2
   if (D == 0) then
      x1 = -b/(2*a)
      x2 = x1
    else if (D > 0) then
      d1 = sqrt(D)
      if (b >= 0) d1 = -d1
      s  = (-b + d1)/2
      x1 = s/a
      x2 = c/s
    else
      nroot = -2
      x1 = -b/(2*a)
      x2 = sqrt(-D)/(2*a)
   endif
end subroutine quadratic
