!  4.5 Q[EKEXϕ@\Ԃ̐ϕ\
program laguerre_test
   implicit none
   external func
   real func,s
   integer k
   call Laguerre_Gauss(func,s)
   print *,'S = ',s
end program laguerre_test

function func(x)
   implicit none
   real func,x
   func = x**12 - 4*x**5 + 2
end function func

subroutine Laguerre_Gauss(fun,s)
   implicit none
   include 'laguerre.inc'            ! t@C}
   real fun,s,s0,x
   integer k
   s0 = 0
   do k = 1, narray
      x =  laposition(k)
      s0 = s0 + laweight(k)*fun(x)
   enddo
   s = s0
end subroutine Laguerre_Gauss
