!  4.7 2dw֐^ϕ
program DE_test
   implicit none
   real func,a,b,s
   integer ind
   external func
   a = -5
   b = 3
   call DEintegral(func,a,b,s,1e-12,ind)
   print *,'S = ',s,ind
end program DE_test

function func(x)
   implicit none
   real func,x
   func = x**12 - 5*x**8 - 4*exp(2*x) - 4*x**2 + 2
end function func

subroutine DEintegral(fun,a,b,s,eps,ind)
   implicit none
   real, parameter :: pi = 3.141592653589793, pid4 = pi/4
   real fun,a,b,s,eps,s0,s1,h,x,w,x1,c1,c2,a1,tmax
   real ex,exd,ex1,ex1d,ff,ep
   integer ind,k,n1,n2,it,n0,ne
   ind = 0
   if (a == b) then
      s = 0
      return
   endif
   c1 = (b-a)/2
   c2 = (b+a)/2
!   tmax = log(150*log(10.0)/(pid4*2))
   tmax = 6
   h  = 0.5
   ep = 0.2*sqrt(eps)
   n1 = -tmax/h
   n2 = tmax/h
   s0 = 0
   ne = 0
   do k = 0, n2
      x =  h*k
      ex = exp(x);     exd = 1/ex
      x1 = pid4*(ex-exd)
      ex1 = exp(x1);   ex1d = 1/ex1
      a1 = (ex1-ex1d)/(ex1+ex1d)
      w = pi*(ex+exd)/(ex1+ex1d)**2
      a1 = c1*a1+c2
      ff = fun(a1)*w
      s0 = s0 + ff
      if (abs(ff) < eps) then
         ne = ne + 1
         if (ne >= 2) exit
       else
         ne = 0
      endif
   enddo
   if (k < n2) n2 = k
   ne = 0
   do k = -1, n1, -1
      x =  h*k
      ex = exp(x);     exd = 1/ex
      x1 = pid4*(ex-exd)
      ex1 = exp(x1);   ex1d = 1/ex1
      a1 = (ex1-ex1d)/(ex1+ex1d)
      w = pi*(ex+exd)/(ex1+ex1d)**2
      a1 = c1*a1+c2
      ff = fun(a1)*w
      s0 = s0 + ff
      if (abs(ff) < eps) then
         ne = ne + 1
         if (ne >= 2) exit
       else
         ne = 0
      endif
   enddo
   if (k > n1) n1 = k
   n0 = n2-n1+1
   s0 = s0*h
   do it = 1, 20
      n1 = n1*2
      n2 = n2*2
      h  = h/2
      s1 = 0
      do k = n1+1, n2-1, 2
         x =  h*k
         ex = exp(x);     exd = 1/ex
         x1 = pid4*(ex-exd)
         ex1 = exp(x1);   ex1d = 1/ex1
         a1 = (ex1-ex1d)/(ex1+ex1d)
         w = pi*(ex+exd)/(ex1+ex1d)**2
         a1 = c1*a1+c2
         s1 = s1 + fun(a1)*w
      enddo
      s1 = s0/2 + s1*h
      n0 = n0 + (n2-n1)/2 - 1
      if (abs(s1-s0) < ep) exit
      s0 = s1
   enddo
   s = s1*c1
   ind = n0
   if (it > 20) ind = -ind
end subroutine DEintegral
