!  6.2 Kz֐̋t֐
program inverse_normal_distrib
   implicit none
   integer i
   real invdnormal,x,h
   h = 1e-4
   do i = 1, 9999
      x = h*i
      print *,x,invdnormal(x)
   enddo
end program inverse_normal_distrib

function invdnormal(x)
   implicit none
   real x,invdnormal,xa,y,z
   integer i
   real :: c(11) = (/ &
         0.1570796288e+1,  0.3706987906e-1, -0.8364353589e-3, &
        -0.2250947176e-3,  0.6841218299e-5,  0.5824238515e-5, &
        -0.1045274970e-5,  0.8360937017e-7, -0.3231081277e-8, & 
         0.3657763036e-10, 0.6936233982e-12 /)
   if (x == 0.5) then
      invdnormal = 0
      return
   endif
   if (x <= 0 .or. x >= 1) then
      invdnormal = 1d100
      write(*,*) 'Error in function invdnormal: Out of bounds x = ',x
      return
   endif
   if (x > 0.5) then
      xa = 1 - x
    else
      xa = x
   endif
   if (xa > 3.8e-7) then
      y = -log(4*xa*(1-xa))
      z = c(11)
      do i = 10, 1, -1
         z = z*y + c(i)
      enddo
      y = sqrt(y*z)
    else
      y = sqrt(-2*log(xa))
      y = y - (2.30753+0.27061*y)/(1 + y*(0.99229+0.04481*y))
   endif
   if (x > 0.5) then
      invdnormal = -y
    else
      invdnormal = y
   endif
end function invdnormal
