!  6.9 1튮Sȉ~ϕ
program test_elliptic_integral
   implicit none
   real ellipticK,k,h
   integer i,n
   n = 1000
   h = 0.001
   do i = 1, n-1
      k = h*i
      print *,k,ellipticK(k,0),ellipticK(k,1)
   enddo
end program test_elliptic_integral

function ellipticK(k,mode)
   implicit none
   real, parameter :: pi = 3.141592653589793
   real q,nome_q,k,ellipticK,k2,k20,kd,q2,q3
   integer mode
   k2 = k*k;      k20 = k2
   if (mode /= 0) k2 = 1 - k2
   if (k2 >= 1) then
      ellipticK = 1d100
      write(*,*) 'Error in function ellipticK: k = ',k
      return
   endif
   if (k2 > 0.5) then
      if (mode == 0) k20 = 1 - k2
      q = nome_q(k20)
      q2 = q*q;      q3 = q2*q
      kd = 0.5*(1 + 2*q*(1 + q3*(1 + q3*q2)))**2
      ellipticK = -kd*log(q)
    else
      q = nome_q(k2)
      q2 = q*q;      q3 = q2*q
      ellipticK = 0.5*pi*(1 + 2*q*(1 + q3*(1 + q3*q2)))**2
   endif
end function ellipticK

function nome_q(k2)
   implicit none
   real nome_q,k2,kd,ep,ep4
   if (k2 == 0) then
      nome_q = 0
    else
      kd = sqrt(1 - k2)
      ep = 0.5*k2/((1+2*sqrt(kd)+kd)*(1+kd))
      ep4 = ep*ep
      ep4 = ep4*ep4
      nome_q = ep*(1 + ep4*(2+ep4*(15+ep4*150)))
   endif
end function nome_q
