!  7.5 d̉@@\A@\
program backward_euler
   implicit none
   real x0,y0,z0,h
   real a11,a12,a21,a22,b1,b2,det
   integer n,nmax
   x0 = 0
   y0 = 1
   z0 = 0
   h  = 0.02
   nmax =100
   print *,'x, y, z = ',x0,y0,z0
   a11 = 1 - 998*h
   a12 = -1998*h
   a21 = 999*h
   a22 = 1 + 1999*h
   det = a11*a22 - a12*a21
   do n = 1, nmax
      b1 = y0
      b2 = z0
      y0 = (b1*a22 - a12*b2)/det
      z0 = (a11*b2 - a21*b1)/det
      x0 = x0 + h
      print *,'x, y, z = ',x0,y0,z0
   enddo
end program backward_euler
