!  7.7 2_El̉@@\ɂ@\
program boundary_value
   implicit none
   integer, parameter :: nm = 100
   real x,v(0:100),fh(nm-1),h,xmax
   real, parameter :: pi = 3.141592653589793
   integer i
   xmax  = 10
   h     = xmax/nm
   v(0)  = 1
   v(nm) = 5
   do i = 1, nm-1
      x = h*i
      fh(i) = sin(3*pi*x/xmax)*h*h
   enddo
   call tridiagonal121(fh,nm,v)
   do i = 0, nm
      x = h*i
      print *,' x, V(x) = ',x,v(i)
   enddo
end program boundary_value

subroutine tridiagonal121(f,n,v)
   implicit none
   real f(*),v(0:n)
   real G(0:n),H(0:n)
   integer i,n
   G(0) = 0
   H(0) = v(0)
   do i = 1, n-1
      G(i) = -1/(-2 + G(i-1))
      H(i) = -(f(i) - H(i-1))*G(i)
   enddo
   do i = n-1, 1, -1
      v(i) = G(i)*v(i+1) + H(i)
   enddo
end subroutine tridiagonal121
