!  8.1 1M`̉@1@\z@\
program thermal_explicit
   implicit none
   integer, parameter :: imax = 100
   real T(0:imax),T2(0:imax),xmax,x,dx,dt,kp,kdt
   integer i,nt,ntmax
   kp   = 1
   xmax = 10
   dx   = xmax/imax
   dt   = 0.004
   kdt  = kp*dt/(dx*dx)
   ntmax = 2500
   do i = 0, imax
      x = dx*i
      if (i < imax/2) then
         T(i) = x
       else
         T(i) = xmax - x
      endif
      write(10,*) i,x,T(i)
   enddo
   do nt = 1, ntmax
      do i = 1, imax-1
         T2(i) = T(i) + kdt*(T(i-1) - 2*T(i) + T(i+1))
      enddo
      do i = 1, imax-1
         T(i) = T2(i)
      enddo
   enddo
   do i = 0, imax
      x = dx*i
      write(11,*) i,x,T(i)
   enddo
   print *,'Stored Initial Data -> 10'
   print *,'Stored Final   Data -> 11'
end program thermal_explicit
