!  8.5 1ڗ̉@2@\2iKbNXEEFht@\
program advection_Lax_Wendroff
   implicit none
   integer, parameter :: imax = 200
   real F(0:imax),F2(0:imax),xmax,x,dx,dt,u,cfl
   integer i,nt,ntmax
   u   = 1
   xmax = 200
   dx   = xmax/imax
   dt   = 0.4
   cfl  = u*dt/dx
   ntmax = 250
   do i = 0, imax
      x = dx*i
      if (i >= 20 .and. i <= 50) then
         F(i) = 1
       else
         F(i) = 0
      endif
      write(10,*) i,x,F(i)
   enddo
   do nt = 1, ntmax
      do i = 0, imax-1
         F2(i) = 0.5*(F(i)+F(i+1)) - (cfl/2)*(F(i+1) - F(i))
      enddo
      do i = 1, imax-1
         F(i) = F(i) - cfl*(F2(i) - F2(i-1))
      enddo
   enddo
   do i = 0, imax
      x = dx*i
      write(11,*) i,x,F(i)
   enddo
   print *,'Stored Initial Data -> 10'
   print *,'Stored Final   Data -> 11'
end program advection_Lax_Wendroff
