!  10.3 f[^̕בւ2@@\q[v\[g\
program heap_sort_test
   implicit none
   integer, parameter :: n0 = 70000
   real xp(n0)
   integer i
   call random_number(xp(1:n0))
   call heap_sort(xp,n0)
   do i = 1, n0
      print *,i,xp(i)
   enddo
end program heap_sort_test

subroutine heap_sort(a,n)
   implicit none
   real a(n),x
   integer n,i,ie,i0,i1,i2
   do i = n/2, 1, -1
      x = a(i);    ie = n+1
      i0 = i;      i1 = i0*2
      do while (i1 < ie)        ! loop1
         i2 = i1+1
         if (i2 < ie .and. a(i1) < a(i2)) i1 = i2
         if (a(i1) > x) then
            a(i0) = a(i1);     a(i1) = x
          else
            exit
         endif
         i0 = i1;     i1 = i0*2
      enddo
   enddo
   do ie = n, 2, -1
      x = a(ie)
      a(ie) = a(1)
      a(1) = x
      i0 = 1;     i1 = 2
      do while (i1 < ie)       ! loop2
         i2 = i1+1
         if (i2 < ie .and. a(i1) < a(i2)) i1 = i2
         if (a(i1) > x) then
            a(i0) = a(i1);     a(i1) = x
          else
            exit
         endif
         i0 = i1;     i1 = i0*2
      enddo
   enddo
end subroutine heap_sort
