!  2.3 `̔@1@\@\
program x_cosx
   implicit none
   real x1,x2,eps
   integer it,itmax
   x1  = 0
   eps = 1e-10
   itmax = 100
   do it = 1, itmax
      x2 = cos(x1)
      if (abs(x2-x1) < eps) exit
      x1 = x2
   enddo
   if (it > itmax) then
      print *,'No Convergence !'
    else
      print *,'X = ',x2,cos(x2)-x2,it
   endif
end program x_cosx
