!  4.1 `
program trapesoidal_integral
   implicit none
   real func,x,a,b,h,s
   integer k,nmax
   nmax = 100
   a = -2
   b = 5
   h = (b-a)/nmax
   s = 0.5*(func(a) + func(b))
   do k = 1, nmax-1
      x = a + h*k
      s = s + func(x)
   enddo
   s = s*h
   print *,'S = ',s
end program trapesoidal_integral

function func(x)
   implicit none
   real func,x
   func = x**6 - 6*x**2 + 3*x + 2
end function func
