!  4.2 Vv\̌
program Simpson_test
   implicit none
   real func,a,b,s
   external func
   a = -2
   b = 5
   call Simpson_rule(func,a,b,100,s)
   print *,'S = ',s
end program Simpson_test

function func(x)
   implicit none
   real func,x
   func = x**6 - 6*x**2 + 3*x + 2
end function func

subroutine Simpson_rule(fun,a,b,n,s)
   implicit none
   real fun,a,b,s,h,x
   integer n,i
   h = (b-a)/n
   s = fun(a) + fun(b) + 4*fun(b-h)
   do i = 1, n-3, 2
      x = a + h*i
      s = s + 4*fun(x) + 2*fun(x+h)
   enddo
   s = s*h/3
end subroutine Simpson_rule
