!  4.4 WhEKEXϕ
program legendre_test
   implicit none
   external func
   real func,a,b,s
   a = -5
   b = 3
   call Legendre_Gauss(func,a,b,s)
   print *,'S = ',s
end program legendre_test

function func(x)
   implicit none
   real func,x
   func = x**12 - 5*x**8 - 4*exp(2*x) - 4*x**2 + 2
end function func

subroutine Legendre_Gauss(fun,a,b,s)
   implicit none
   include 'legendre.inc'            ! t@C}
   real fun,a,b,s,s0,x1,x2,c1,c2
   integer k,n1
   if (a == b) then
      s = 0
      return
   endif
   c1 = (b-a)/2
   c2 = (b+a)/2
   if (leposition(1) == 0) then
      s0 = leweight(1)*fun(c2)
      n1 = 2
    else
      s0 = 0
      n1 = 1
   endif
   do k = n1, narray
      x1 =  c1*leposition(k)+c2
      x2 = -c1*leposition(k)+c2
      s0 = s0 + leweight(k)*(fun(x1)+fun(x2))
   enddo
   s = s0*c1
end subroutine Legendre_Gauss
