!  4.6 G~[gEKEXϕ@\SԂ̐ϕ\
program hermite_test
   implicit none
   external func
   real func,s
   integer k
   call Hermite_Gauss(func,s)
   print *,'S = ',s
end program hermite_test

function func(x)
   implicit none
   real func,x
   func = x**12 - 4*x**4 + 2
end function func

subroutine Hermite_Gauss(fun,s)
   implicit none
   include 'hermite.inc'            ! t@C}
   real fun,s,s0,x1,x2
   integer k,n1
   if (heposition(1) == 0) then
      x1 =  0
      s0 = s0 + heweight(1)*fun(x1)
      n1 = 2
    else
      s0 = 0
      n1 = 1
   endif
   do k = n1, narray
      x1 =  heposition(k)
      x2 = -heposition(k)
      s0 = s0 + heweight(k)*(fun(x1)+fun(x2))
   enddo
   s = s0
end subroutine Hermite_Gauss
