!  4.9 eJ@ɂ闧̂̑̐όvZ
program Monte_Carlo
   implicit none
   real, parameter :: pi = 3.141592653589793, pi4 = pi*4
   integer, parameter :: nmax = 10000
   real V,ran(3),x,y,z,r,th,ph,r1,rmax
   integer n
   rmax = 1.1
   V  = 0
   do n = 1, nmax
      call random_number(ran(1:3))
      x = rmax*(ran(1)*2-1)
      y = rmax*(ran(2)*2-1)
      z = rmax*(ran(3)*2-1)
      r = sqrt(x*x+y*y+z*z)
      ph = atan2(y,x)
      th = acos(z/r)
      r1 = 1+0.1*cos(10*th)*cos(6*ph)
      if (r < r1) V = V + 1
   enddo 
   print *,'V = ',8*rmax**3*V/nmax
end program Monte_Carlo
