!  6.1 덷֐
program error_test
   implicit none
   real errfunc,x,h
   integer i
   h = 0.001
   do i = 0, 6000
      x = h*i
      print *,x,errfunc(x)
   enddo
end program error_test

function errfunc(x)
   implicit none
   real x,y,xa,t,errfunc
   real :: c(5) = (/ 0.254829592, -0.284496736, &
                     1.421413741, -1.453152027, 1.061405429 /)
   real :: p = 0.3275911
   if (x == 0) then
      errfunc = 0
      return
   endif
   xa = abs(x)
   t = 1/(1+p*xa)
   y = t*(c(1) + t*(c(2) + t*(c(3) + t*(c(4) + t*c(5)))))
   errfunc = 1 - y*exp(-xa*xa)
   if (x < 0) errfunc = -errfunc
end function errfunc
