!  7.6 ۑۏ؂^̉@@\VvNeBbN@\
program henon_heires_map
   implicit none
   real t0,x0,y0,px0,py0,q(2),p(2),h,yp,pyp
   integer nt,ntmax,nm
   t0  = 0
   x0  = 0
   px0 = 0.2
   y0  = 0
   py0 = 0
   q(1) = x0
   q(2) = y0
   p(1) = px0
   p(2) = py0
   h  = 0.2
   ntmax = 200000
   nm = 0
   do nt = 1, ntmax
      call symplectic_2nd(t0,h,q,p)
      if (x0 <= 0 .and. q(1) > 0) then
         nm  = nm + 1
         yp  = y0  - (q(2)-y0)/(q(1)-x0)*x0
         pyp = py0 - (p(2)-py0)/(q(1)-x0)*x0
         print *,nm,yp,pyp
      endif
      x0  = q(1)
      y0  = q(2)
      px0 = p(1)
      py0 = p(2)
   enddo
end program henon_heires_map

subroutine symplectic_2nd(tn,h,q,p) 
   implicit none
   real tn,h,h2,q(*),p(*)
   h2   = h/2
   q(1) = q(1) + p(1)*h2
   q(2) = q(2) + p(2)*h2
   p(1) = p(1) + (-q(1)-2*q(1)*q(2))*h
   p(2) = p(2) + (-q(2)-q(1)*q(1)+q(2)*q(2))*h
   q(1) = q(1) + p(1)*h2
   q(2) = q(2) + p(2)*h2
   tn = tn + h
end subroutine symplectic_2nd
