!  8.6 1ڗ̉@3@\TVD@\
program advection_TVD
   implicit none
   integer, parameter :: imax = 200
   real F(0:imax),F2(0:imax),bi,xmax,x,dx,dt,u,cfl,ri
   integer i,nt,ntmax
   u   = 1
   xmax = 200
   dx   = xmax/imax
   dt   = 0.4
   cfl  = u*dt/dx
   ntmax = 300
   do i = 0, imax
      x = dx*i
      if (i >= 20 .and. i <= 50) then
         F(i) = 1
       else
         F(i) = 0
      endif
      write(10,*) i,x,F(i)
   enddo
   do nt = 1, ntmax
      do i = 1, imax
         if (F(i+1) == F(i)) then
            F2(i) = F(i)
          else
            ri = (F(i)-F(i-1))/(F(i+1)-F(i))
            bi = min(max(ri,0.0),1.0)
            F2(i) = F(i) + 0.5*(1-cfl)*bi*(F(i+1)-F(i))
         endif
      enddo
      do i = 1, imax-1
         F(i) = F(i) - cfl*(F2(i) - F2(i-1))
      enddo
   enddo
   do i = 0, imax
      x = dx*i
      write(11,*) i,x,F(i)
   enddo
   print *,'Stored Initial Data -> 10'
   print *,'Stored Final   Data -> 11'
end program advection_TVD
