!  10.1 gݗď@
program synthetic_division_test
   implicit none
   integer, parameter :: n0 = 10
   real p0(0:n0),q0(0:n0),pa,dp,a
   real ps(0:n0),p2(0:1),del
   integer i,ns
   a = -2
   do i = 0, n0
      p0(i) = i*2-5
   enddo
   call synthetic_division(p0,n0,a,q0,pa,dp)
   print *,"a, p(a), p'(a) = ",a,pa,dp
   do i = 0, n0-1
      print *,i,q0(i)
   enddo
   p2(1) = 1;  p2(0) = -a
   call polynom_mult(q0,n0-1,p2,1,ps,ns)
   ps(0) = ps(0) + pa
   del = 0
   do i = 0, n0
      del = max(del,abs(ps(i)-p0(i)))
   enddo
   print *,del
end program synthetic_division_test

subroutine synthetic_division(p,n,a,q,pa,dp)
   implicit none
   real p(0:n),q(0:n),a,pa,dp
   integer n,i
   pa = p(n)
   dp = 0
   do i = n-1, 0, -1
      q(i) = pa
      dp = dp*a + pa
      pa = pa*a + p(i)
   enddo
end subroutine synthetic_division

subroutine polynom_mult(p1,n1,p2,n2,ps,ns) 
   implicit none
   real p1(0:n1),p2(0:n2),ps(0:*)
   integer n1,n2,ns,i,j
   ns = n1 + n2
   ps(0:ns) = 0
   do j = 0, n2
      do i = 0, n1
         ps(i+j) = ps(i+j) + p1(i)*p2(j)
      enddo
   enddo
end subroutine polynom_mult
