!  10.6 AXg
program linked_list_test
   implicit none
   integer, parameter :: n0 = 100, m0 = 10
   real nrand(n0),x1,x2
   integer m,i,lhead(0:m0-1),llist(n0),nn
   x1 = 0
   x2 = 100
   call normal_random(nrand,n0,18.0,55.0)
   call linked_list(nrand,n0,x1,x2,lhead,llist,m0)
   do m = 0, m0-1
      i = lhead(m)
      nn = 0
      do while (i > 0)
         print "(a,i5$)",'   ',i        ! тɏo͂
         i = llist(i)
         nn = nn + 1
      enddo
      print "(/ i5,a,i5)",nn,' Exist in ',m
   enddo
end program linked_list_test

subroutine linked_list(a,n,amin,amax,lhead,llist,md)
   implicit none
   real a(*),amin,amax,h
   integer n,lhead(0:md-1),llist(n),md
   integer i,m
   lhead(:) = 0;   llist(:) = 0
   h = (amax-amin)/md
   do i = 1, n
      m = (a(i)-amin)/h
      if (m < 0) then
         m = 0
       else if (m > md-1) then
         m = md-1
      endif
      if (lhead(m) == 0) then
         lhead(m) = i
       else
         llist(i) = lhead(m)
         lhead(m) = i
      endif
   enddo
end subroutine linked_list

subroutine normal_random(nran,n,sig,x0)
   implicit none
   real, parameter :: pi  = 3.141592653589793, pi2 = 2*pi
   real nran(n),sig,x0,ang,dd
   integer n,i
   call random_number(nran(1:n))
   do i = 1, n, 2
      ang = pi2*nran(i+1)
      dd  = sig*sqrt(-2*log(nran(i)))
      nran(i)   = dd*cos(ang) + x0
      nran(i+1) = dd*sin(ang) + x0
   enddo
   if (mod(n,2) == 1) then
      call random_number(ang)
      ang = pi2*ang
      dd  = sig*sqrt(-2*log(nran(n)))
      nran(n) = dd*cos(ang) + x0
   endif
end subroutine normal_random
